<?php

/*******************************************
* SimpleTickers
* Version 1.5
* © mamavrn.ru
* License - http://creativecommons.org/licenses/by-sa/3.0/ CC BY-SA 3.0
********************************************
* Subs-SimpleTickers.php
*******************************************/

if (!defined('SMF')) 
    die('Hacking attempt...');
    
function ticker_menu_buttons(&$buttons) 
{
	global $txt, $modSettings, $scripturl;
    
	loadLanguage('SimpleTickers');
	if (!isset($modSettings['simpletickers_enable'])) $modSettings['simpletickers_enable'] = '1';
	$counter = 0;
	foreach ($buttons as $name => $array) 
	{ 
		$counter++;
		if ($name == 'calendar') 
		break;
	} 
 
	$buttons = array_merge( 
	array_slice($buttons, 0, $counter, true),
	array('simpletickers' => array( 
		'title' => $txt['simpletickers_label'], 
		'href' => $scripturl . '?action=simpletickers', 
		'show' => $modSettings['simpletickers_enable'], 
		'sub_buttons' => array(), 
		)),
	array_slice($buttons, $counter, NULL, true) 
	);
}

function ticker_action(&$actionArray) 
{
	$actionArray['simpletickers'] = array('SimpleTickers.php', 'SimpleTickersMain');
}

function ticker_settings(&$config_vars)
{
	global $txt, $modSettings;
    
	loadLanguage('SimpleTickers');
	if (isset($config_vars[0])) $config_vars[] = array('title', 'simpletickers_title');  
	$config_vars[] = array('check', 'simpletickers_enable');
	$config_vars[] = '';
	$config_vars[] = array('check', 'simpletickers_shorturl');
	$config_vars[] = '';
	$config_vars[] = array('int', 'simpletickers_linecolcount');
	$config_vars[] = '';
	$config_vars[] = array('int', 'simpletickers_begcolcount');
	$config_vars[] = '';
	$config_vars[] = array('large_text', 'simpletickers_captions');
	$config_vars[] = '';
	$config_vars[] = array('select', 'simpletickers_encoding', array('utf-8' => 'utf-8', 'cp-1251' => 'cp-1251'));
	$config_vars[] = '';
	$config_vars[] = array('text', 'simpletickers_dayword');
	$config_vars[] = array('text', 'simpletickers_daysword');
	$config_vars[] = array('text', 'simpletickers_monthword');
	$config_vars[] = array('text', 'simpletickers_monthsword');
	$config_vars[] = array('text', 'simpletickers_yearword');
	$config_vars[] = array('text', 'simpletickers_yearsword');
}

function generateShortUrl($length = 4){
	$chars = 'abdefhiknrstyzABDEFGHKNQRSTYZ23456789';
	$numChars = strlen($chars);
	$string = '';
	for ($i = 0; $i < $length; $i++) {
		$string .= substr($chars, rand(1, $numChars) - 1, 1);
	}
	return $string;
};

function TickerParamToDB($shu, $l, $b, $d, $fo, $c, $t){

	global $smcFunc;

	$smcFunc['db_insert']('ignore',
		'{db_prefix}tickers',
		array('RANDOMURL' => 'string-255', 'LINE' => 'string-255', 'BEG' => 'string-255', 'STARTDATE' => 'string-255', 'FONT' => 'string-255', 'COLOR' => 'string-255', 'CAPT' => 'string-255'),
		array($shu, $l, $b, $d, $fo, $c, $t),
		array('RANDOMURL'));
};

function GenerateUrl($l, $n, $m, $y, $f, $b, $c, $t){

	global $modSettings, $boardurl;

	if((isset($n))&(isset($m))&(isset($y))) $d=$n.','.$m.','.$y; else $d='11,11,2011';
	if(!isset($f)) $f='LiberationMono-Regular';
	if(!isset($l)) $l='1a.png';
	if(!isset($b)) $b='01.png';
	if(!isset($c)) $c='000000';
	if(!isset($t)) $t='';

	if (!isset($modSettings['simpletickers_shorturl']))
		$modSettings['simpletickers_shorturl'] = '0';

	if ($modSettings['simpletickers_shorturl'])
	{
		$shu=generateShortUrl(4);
		TickerParamToDB($shu, $l, $b, $d, $f, $c, $t);
		return $boardurl."/SimpleTickers/img.php?pa=".$shu;
	}else 
		return $boardurl."/SimpleTickers/img.php?l=".$l."&b=".$b."&d=".$d."&f=".$f."&c=".$c."&t=".$t;
}

function hex2RGB($hexStr, $returnAsString = false, $seperator = ',') {
	$hexStr = preg_replace("/[^0-9A-Fa-f]/", '', $hexStr); 
	$rgbArray = array();
	if (strlen($hexStr) == 6) {
		$colorVal = hexdec($hexStr);
		$rgbArray['red'] = 0xFF & ($colorVal >> 0x10);
		$rgbArray['green'] = 0xFF & ($colorVal >> 0x8);
		$rgbArray['blue'] = 0xFF & $colorVal;
	} elseif (strlen($hexStr) == 3) {
		$rgbArray['red'] = hexdec(str_repeat(substr($hexStr, 0, 1), 2));
		$rgbArray['green'] = hexdec(str_repeat(substr($hexStr, 1, 1), 2));
		$rgbArray['blue'] = hexdec(str_repeat(substr($hexStr, 2, 1), 2));
	} else return false;
	
	return $returnAsString ? implode($seperator, $rgbArray) : $rgbArray; 
};

function setTransparency($new_image, $image_source)
{
	$transparencyIndex = imagecolortransparent($image_source);
	$transparencyColor = array('red' => 255, 'green' => 255, 'blue' => 255);
        
	if ($transparencyIndex >= 0)
		$transparencyColor = imagecolorsforindex($image_source, $transparencyIndex);   
        
	$transparencyIndex = imagecolorallocate($new_image, $transparencyColor['red'], $transparencyColor['green'], $transparencyColor['blue']);
	imagefill($new_image, 0, 0, $transparencyIndex);
	imagecolortransparent($new_image, $transparencyIndex);
};

function diff($base_day,$base_mon,$base_yr)
{

	global $context, $modSettings, $txt;

	$current_day = date ("j");
	$current_mon = date ("n");
	$current_yr = date ("Y");
	if(mktime (0,0,0,$base_mon,$base_day,$base_yr)>time())
	{	
		$raznica=intval(mktime (0,0,0,$base_mon,$base_day,$base_yr))-intval(time());
		$r1=$base_day;
		$r2=$base_mon;
		$r3=$base_yr;
		$base_day=date("j");
		$base_mon=date("n");
		$base_yr=date("Y");
		$current_day=$r1;
		$current_mon=$r2;
		$current_yr=$r3;
	}
	else $raznica = intval(time())-intval(mktime (0,0,0,$base_mon,$base_day,$base_yr));
	$base_mon_max = date ("t",mktime (0,0,0,$base_mon,$base_day,$base_yr));
	$base_day_diff = $base_mon_max - $base_day;
	$base_mon_diff = 12 - $base_mon - 1;
	$start_day = 1;
	$start_mon = 1;
	$start_yr = $base_yr + 1;
	$day_diff = ($current_day - $start_day) + 1; 	
	$mon_diff = ($current_mon - $start_mon) + 1;
	$yr_diff = ($current_yr - $start_yr);
	$day_diff = $day_diff + $base_day_diff;
	$mon_diff = $mon_diff + $base_mon_diff;
	if ($day_diff >= $base_mon_max)
	{
		$day_diff = $day_diff - $base_mon_max;
		$mon_diff = $mon_diff + 1;
	}
	if ($mon_diff >= 12)
	{
		$mon_diff = $mon_diff - 12;
		$yr_diff = $yr_diff + 1;
	}
	$a_d=array('1','21','31');
	$b_d=array('2','3','4','22','23','24');
	if (in_array ($day_diff, $a_d))
		if (empty($modSettings['simpletickers_dayword'])) $days=$txt['simpletickers_den'];
			else $days=$modSettings['simpletickers_daysword'];
		else if (in_array ($day_diff, $b_d))
			if (empty($modSettings['simpletickers_dayword'])) $days=$txt['simpletickers_dnya'];
				else $days=$modSettings['simpletickers_daysword'];
	else 
		if (empty($modSettings['simpletickers_dayword'])) $days=$txt['simpletickers_dnei'];
			else $days=$modSettings['simpletickers_daysword'];
	if($mon_diff=="1")
		if (empty($modSettings['simpletickers_monthword']))
			$month=$txt['simpletickers_mesyac'];
		else
			$month=$modSettings['simpletickers_monthword'];
	else if($mon_diff>"1" && $mon_diff<"5")
		if (empty($modSettings['simpletickers_monthsword']))
			$month=$txt['simpletickers_mesyaca'];
		else
			$month=$modSettings['simpletickers_monthsword'];
	else
		if (empty($modSettings['simpletickers_monthsword']))
			$month=$txt['simpletickers_mecyacev'];
		else
			$month=$modSettings['simpletickers_monthsword'];

	$last = strlen($yr_diff); 
	if($last>1)
	{ 
		$yr_diff="".$yr_diff."";
		$yr_dif = $yr_diff{intval($last-1)}; 
		if($yr_dif=="1")
			if (empty($modSettings['simpletickers_yearsword']))
				$y_y=$txt['simpletickers_let'];
			else
				$y_y=$modSettings['simpletickers_yearsword'];
		else 
			if($yr_dif>"1" && $yr_dif<"5")
				if (empty($modSettings['simpletickers_yearsword']))
					$y_y=$txt['simpletickers_goda'];
				else
					$y_y=$modSettings['simpletickers_yearsword'];
		else
			if (empty($modSettings['simpletickers_yearsword']))
				$y_y=$txt['simpletickers_let'];
			else
				$y_y=$modSettings['simpletickers_yearsword'];
	}	
	else if($last=="1")
	{
		if($yr_diff=="1")
			if (empty($modSettings['simpletickers_yearword']))
				$y_y=$txt['simpletickers_god'];
			else
				$y_y=$modSettings['simpletickers_yearword'];
		else if($yr_diff>"1" && $yr_diff<"5")
			if (empty($modSettings['simpletickers_yearsword']))
				$y_y=$txt['simpletickers_goda'];
			else
				$y_y=$modSettings['simpletickers_yearsword'];
		else
			if (empty($modSettings['simpletickers_yearsword']))
				$y_y=$txt['simpletickers_let'];
			else
				$y_y=$modSettings['simpletickers_yearsword'];
	}
	$monthth=$mon_diff." ".$month;
	if($yr_diff!="0")
		$yyy=$yr_diff." ".$y_y;
	else
	{
		$yyy="";
		if($mon_diff=="0")$monthth="";
	}
	return array($yyy." ".$monthth." ".$day_diff." ".$days, $monthth);
}

?>